Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("tns-core-modules/utils/utils");
var app = require("tns-core-modules/application");
var CONFIRMATION_ACTIVITY_REQUEST_CODE = 5673;
exports.confirm = function (options) {
    return new Promise(function (resolve, reject) {
        var intent = new android.content.Intent(utils_1.ad.getApplicationContext(), com.github.bradmartin.smartwearos.ConfirmationActivity.class);
        intent.putExtra('MESSAGE', options.message);
        if (options.title) {
            intent.putExtra('TITLE', options.title);
        }
        if (options.autoCloseTime) {
            intent.putExtra('AUTO_CLOSE_TIME', options.autoCloseTime);
        }
        var activity = app.android.foregroundActivity || app.android.startActivity;
        activity.startActivityForResult(intent, CONFIRMATION_ACTIVITY_REQUEST_CODE);
        activity.onActivityResult = function (requestCode, resultCode, data) {
            if (requestCode === CONFIRMATION_ACTIVITY_REQUEST_CODE) {
                if (resultCode === android.app.Activity.RESULT_OK) {
                    return resolve(true);
                }
                else if (resultCode === android.app.Activity.RESULT_CANCELED) {
                    return resolve(false);
                }
                else {
                    return resolve(null);
                }
            }
        };
    });
};
