Object.defineProperty(exports, "__esModule", { value: true });
var VUE_VIEW = '__vueVNodeRef__';
function extend(to, _from) {
    for (var key in _from) {
        to[key] = _from[key];
    }
    return to;
}
exports.default = {
    props: {
        items: {
            type: [Array, Object],
            required: true
        },
        '+alias': {
            type: String,
            default: 'item'
        },
        '+index': {
            type: String
        },
        itemTemplateSelector: {
            type: Function,
            default: undefined
        }
    },
    template: "<NativeWearOsListView ref=\"listView\" :items=\"items\" v-bind=\"$attrs\" v-on=\"listeners\" @itemTap=\"onItemTap\" @itemLoading=\"onItemLoading\"\n  >\n  <slot /></NativeWearOsListView>",
    watch: {
        items: {
            handler: function (newVal) {
                this.$refs.listView.setAttribute('items', newVal);
                this.refresh();
            },
            deep: true
        }
    },
    created: function () {
        var listeners = extend({}, this.$listeners);
        delete listeners.itemTap;
        this.listeners = listeners;
        this.getItemContext = getItemContext.bind(this);
    },
    mounted: function () {
        var _this = this;
        if (!this.$templates) {
            return;
        }
        this.$refs.listView.setAttribute('_itemTemplatesInternal', this.$templates.getKeyedTemplates());
        this.$refs.listView.setAttribute('_itemTemplateSelector', function (item, index) {
            return _this.$templates.selectorFn(_this.getItemContext(item, index));
        });
    },
    methods: {
        onItemTap: function (args) {
            this.$emit('itemTap', Object.assign({ item: this.items[args.index] }, args));
        },
        onItemLoading: function (args) {
            if (!this.$templates) {
                return;
            }
            var index = args.index;
            var items = args.object.items;
            var currentItem = typeof items.getItem === 'function'
                ? items.getItem(index)
                : items[index];
            console.log('onItemLoading', index, !!currentItem);
            var name = args.object._itemTemplateSelector(currentItem, index, items);
            var context = this.getItemContext(currentItem, index);
            var oldVnode = args.view && args.view[VUE_VIEW];
            console.log('onItemLoading1', name, args.view);
            args.view = this.$templates.patchTemplate(name, context, oldVnode);
            console.log('onItemLoading2', name, args.view);
        },
        refresh: function () {
            this.$refs.listView.nativeView.refresh();
        },
        scrollToIndex: function (index, animate, snapMode) {
            if (animate === void 0) { animate = false; }
            if (snapMode === void 0) { snapMode = 0; }
            this.listView.nativeView.scrollToIndex(index, animate, snapMode);
        },
        getSelectedItems: function () {
            return this.listView.nativeView.getSelectedItems();
        }
    }
};
function getItemContext(item, index, alias, index_alias) {
    var _a;
    if (alias === void 0) { alias = this.$props['+alias']; }
    if (index_alias === void 0) { index_alias = this.$props['+index']; }
    return _a = {},
        _a[alias] = item,
        _a[index_alias || '$index'] = index,
        _a.$even = index % 2 === 0,
        _a.$odd = index % 2 !== 0,
        _a;
}
